Codeforces Round 307 (Div. 2) |
---|

Finished |

Virtual contest is a way to take part in past contest, as close as possible to participation on time. It is supported only ICPC mode for virtual contests.
If you've seen these problems, a virtual contest is not for you - solve these problems in the archive.
If you just want to solve some problem from a contest, a virtual contest is not for you - solve this problem in the archive.
Never use someone else's code, read the tutorials or communicate with other person during a virtual contest.

binary search

greedy

*2200

No tag edit access

The problem statement has recently been changed. View the changes.

×
C. GukiZ hates Boxes

time limit per test

2 secondsmemory limit per test

256 megabytesinput

standard inputoutput

standard outputProfessor GukiZ is concerned about making his way to school, because massive piles of boxes are blocking his way.

In total there are *n* piles of boxes, arranged in a line, from left to right, *i*-th pile (1 ≤ *i* ≤ *n*) containing *a*_{i} boxes. Luckily, *m* students are willing to help GukiZ by removing all the boxes from his way. Students are working simultaneously. At time 0, all students are located left of the first pile. It takes one second for every student to move from this position to the first pile, and after that, every student must start performing sequence of two possible operations, each taking one second to complete. Possible operations are:

- If
*i*≠*n*, move from pile*i*to pile*i*+ 1; - If pile located at the position of student is not empty, remove one box from it.

GukiZ's students aren't smart at all, so they need you to tell them how to remove boxes before professor comes (he is very impatient man, and doesn't want to wait). They ask you to calculate minumum time *t* in seconds for which they can remove all the boxes from GukiZ's way. Note that students can be positioned in any manner after *t* seconds, but all the boxes must be removed.

Input

The first line contains two integers *n* and *m* (1 ≤ *n*, *m* ≤ 10^{5}), the number of piles of boxes and the number of GukiZ's students.

The second line contains *n* integers *a*_{1}, *a*_{2}, ... *a*_{n} (0 ≤ *a*_{i} ≤ 10^{9}) where *a*_{i} represents the number of boxes on *i*-th pile. It's guaranteed that at least one pile of is non-empty.

Output

In a single line, print one number, minimum time needed to remove all the boxes in seconds.

Examples

Input

2 1

1 1

Output

4

Input

3 2

1 0 2

Output

5

Input

4 100

3 4 5 4

Output

5

Note

First sample: Student will first move to the first pile (1 second), then remove box from first pile (1 second), then move to the second pile (1 second) and finally remove the box from second pile (1 second).

Second sample: One of optimal solutions is to send one student to remove a box from the first pile and a box from the third pile, and send another student to remove a box from the third pile. Overall, 5 seconds.

Third sample: With a lot of available students, send three of them to remove boxes from the first pile, four of them to remove boxes from the second pile, five of them to remove boxes from the third pile, and four of them to remove boxes from the fourth pile. Process will be over in 5 seconds, when removing the boxes from the last pile is finished.

Codeforces (c) Copyright 2010-2023 Mike Mirzayanov

The only programming contests Web 2.0 platform

Server time: Dec/09/2023 07:41:25 (g1).

Desktop version, switch to mobile version.

Supported by

User lists

Name |
---|